unit MainGridUnit;

(**************************************************************************
  Windows 10
  Embarcadero RAD Studio 10.2.3 Professional (Delphi)
  Firebird 3.0.2
  FMX + TeeGrid 1.06 + FireDAC (TFDQuery)

  When TeeGrid1.DataSource is FDQuery it's impossible to change FQuery.State to dsInsert

  So:
  TeeGrid1.DataSource := FDQuery1;
  FDQuery.Edit ---------- works normally
  FDQuery.Insert --------- doesn't work, the FDQuery1.State returns to dsBrowse

  TeeGrid.DataSource := nil;
  FDQuery.Insert ---------- works normally
******************************************************************************)


interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.FB, FireDAC.Phys.FBDef, FireDAC.FMXUI.Wait,
  FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt,
  Data.Bind.Controls, Data.Bind.Components, Data.Bind.DBScope, FMX.Layouts,
  Fmx.Bind.Navigator, Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  FMXTee.Control, FMXTee.Grid, FMX.StdCtrls, FMX.Controls.Presentation,
  FireDAC.Phys.IBBase;

type
  TGridForm = class(TForm)
    TeeGrid1: TTeeGrid;
    FDConnection1: TFDConnection;
    FDTransaction1: TFDTransaction;
    FDQuery1: TFDQuery;
    BindNavigator1: TBindNavigator;
    BindSourceDB1: TBindSourceDB;
    Panel1: TPanel;
    AddRecBtn: TButton;
    AddRecWithNilBtn: TButton;
    FDUpdateSQL1: TFDUpdateSQL;
    EditRecBtn: TButton;
    FDPhysFBDriverLink1: TFDPhysFBDriverLink;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AddRecBtnClick(Sender: TObject);
    procedure AddRecWithNilBtnClick(Sender: TObject);
    procedure EditRecBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GridForm: TGridForm;

implementation

{$R *.fmx}

uses
  FormEditInsertUnit;

procedure TGridForm.AddRecBtnClick(Sender: TObject);
begin
  EditInsertForm.ShowFormForEditInsert(True);
end;

procedure TGridForm.AddRecWithNilBtnClick(Sender: TObject);
begin
  TeeGrid1.DataSource := nil;                       // !!!!!!!!!!!!!!!!!!!!!!!!!!!
  EditInsertForm.ShowFormForEditInsert(True);
  TeeGrid1.DataSource := FDQuery1;                  // !!!!!!!!!!!!!!!!!!!!!!!!!!
end;

procedure TGridForm.EditRecBtnClick(Sender: TObject);
begin
  EditInsertForm.ShowFormForEditInsert(False);
end;

procedure TGridForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FDQuery1.Active then
    FDQuery1.Close;
  if not FDTransaction1.Active then
    FDTransaction1.Commit;
  if FDConnection1.Connected then
    FDConnection1.Connected := False;
end;

procedure TGridForm.FormShow(Sender: TObject);
begin
  if not FDConnection1.Connected then
    FDConnection1.Connected := True;
  if not FDTransaction1.Active then
    FDTransaction1.StartTransaction;
  if not FDQuery1.Active then
    FDQuery1.Open();
  TeeGrid1.DataSource := FDQuery1;
end;

end.
